<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>entrez_ncbi.py</title>
  <link rel="stylesheet" href="pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>entrez_ncbi.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      <p>Functions used in the function search_term_ncbi of views.py
Currently we support the following 3 function:</p>
<ol>
<li><strong>Search_something</strong> - Manage the Search Term section of the menu
(jump to section in  <a href="models.html">models.py</a>)</li>
<li><strong>Random_string</strong> - Generate random names unique</li>
<li><strong>Search_something_structure</strong> - Manage the Search Term section of
the menu when the user chooses the NCBI Structure database.</li>
</ol>
<p>References:</p>
<p>NCBI : https://www.ncbi.nlm.nih.gov/</p>
<p>Entrez : https://www.ncbi.nlm.nih.gov/Class/MLACourse/Original8Hour/Entrez/</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">random</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">os.path</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">from</span> <span class="nn">django.core.files.storage</span> <span class="kn">import</span> <span class="n">FileSystemStorage</span>
<span class="kn">from</span> <span class="nn">Bio</span> <span class="kn">import</span> <span class="n">Entrez</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      <p>defined in  <a href="models.html">models.py</a></p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">.models</span> <span class="kn">import</span> <span class="n">Url</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <h3><span id="search_something" href="search_something"> Search_something </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">search_something</span><span class="p">(</span><span class="n">term_search</span><span class="p">,</span> <span class="n">max_search</span><span class="p">,</span> <span class="n">user</span><span class="p">,</span> <span class="n">user_name</span><span class="p">,</span> <span class="n">database</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <p>Manage the Search Term section of the menu.
With Entrez you search for the term entered in the NCBI.
The file is downloaded and saved in our database.</p>
<p>Call functions: random_string ()</p>
<p>Arguments:</p>
<p>term_search {str} &ndash; term entered in the input Term</p>
<p>max_search {int} &ndash; number of downloads</p>
<p>user {str} &ndash; user_id</p>
<p>user_name {str} &ndash; the name of the user making the request</p>
<p>database {str} &ndash; in which NCBI database do you want to search</p>
<p>Returns:</p>
<p>[] &ndash; save file</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="s1">&#39;media/&#39;</span><span class="o">+</span><span class="n">user</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">urls</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="n">Entrez</span><span class="o">.</span><span class="n">email</span> <span class="o">=</span> <span class="s2">&quot;estefani.val34@gmail.com&quot;</span>

    <span class="k">with</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">esearch</span><span class="p">(</span><span class="n">db</span><span class="o">=</span><span class="n">database</span><span class="p">,</span>
                        <span class="n">term</span><span class="o">=</span><span class="n">term_search</span><span class="p">,</span>
                        <span class="n">idtype</span><span class="o">=</span><span class="s2">&quot;acc&quot;</span><span class="p">,</span>
                        <span class="n">retmax</span><span class="o">=</span><span class="n">max_search</span><span class="p">)</span> <span class="k">as</span> <span class="n">response</span><span class="p">:</span>
        <span class="n">res</span> <span class="o">=</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="n">response</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">res</span><span class="p">[</span><span class="s1">&#39;Count&#39;</span><span class="p">]</span> <span class="o">!=</span> <span class="s1">&#39;0&#39;</span><span class="p">:</span>

        <span class="n">ide</span> <span class="o">=</span> <span class="s2">&quot;,&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">res</span><span class="p">[</span><span class="s2">&quot;IdList&quot;</span><span class="p">])</span>
        <span class="k">with</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">epost</span><span class="p">(</span><span class="n">database</span><span class="p">,</span> <span class="nb">id</span><span class="o">=</span><span class="n">ide</span><span class="p">)</span> <span class="k">as</span> <span class="n">response</span><span class="p">:</span>
            <span class="n">epost</span> <span class="o">=</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="n">response</span><span class="p">)</span>

        <span class="n">query_key</span> <span class="o">=</span> <span class="n">epost</span><span class="p">[</span><span class="s1">&#39;QueryKey&#39;</span><span class="p">]</span>

        <span class="n">web_env</span> <span class="o">=</span> <span class="n">epost</span><span class="p">[</span><span class="s1">&#39;WebEnv&#39;</span><span class="p">]</span>

        <span class="n">acc_arr</span> <span class="o">=</span> <span class="n">res</span><span class="p">[</span><span class="s1">&#39;IdList&#39;</span><span class="p">]</span>
        <span class="n">acc_arr2</span> <span class="o">=</span> <span class="n">acc_arr</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>

        <span class="k">with</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">efetch</span><span class="p">(</span><span class="n">db</span><span class="o">=</span><span class="n">database</span><span class="p">,</span>
                           <span class="n">retmode</span><span class="o">=</span><span class="s2">&quot;text&quot;</span><span class="p">,</span>
                           <span class="n">rettype</span><span class="o">=</span><span class="s2">&quot;gb&quot;</span><span class="p">,</span>
                           <span class="n">retstart</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
                           <span class="n">retmax</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                           <span class="n">webenv</span><span class="o">=</span><span class="n">web_env</span><span class="p">,</span>
                           <span class="n">query_key</span><span class="o">=</span><span class="n">query_key</span><span class="p">,</span>
                           <span class="n">idtype</span><span class="o">=</span><span class="s2">&quot;acc&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">response</span><span class="p">:</span>
            <span class="n">acc_arr</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>

        <span class="n">lenght</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">acc_arr</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">lenght</span><span class="p">,</span> <span class="mi">1</span><span class="p">):</span>
            <span class="k">with</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">efetch</span><span class="p">(</span><span class="n">db</span><span class="o">=</span><span class="n">database</span><span class="p">,</span>
                               <span class="n">retmode</span><span class="o">=</span><span class="s2">&quot;text&quot;</span><span class="p">,</span>
                               <span class="n">rettype</span><span class="o">=</span><span class="s2">&quot;gb&quot;</span><span class="p">,</span>
                               <span class="n">retstart</span><span class="o">=</span><span class="n">i</span><span class="p">,</span>
                               <span class="n">retmax</span><span class="o">=</span><span class="n">i</span><span class="p">,</span>
                               <span class="n">webenv</span><span class="o">=</span><span class="n">web_env</span><span class="p">,</span>
                               <span class="n">query_key</span><span class="o">=</span><span class="n">query_key</span><span class="p">,</span>
                               <span class="n">idtype</span><span class="o">=</span><span class="s2">&quot;acc&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">response</span><span class="p">:</span>
                <span class="n">acc_arr</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>

        <span class="n">lenght2</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">acc_arr2</span><span class="p">)</span>
        <span class="n">filesy</span> <span class="o">=</span> <span class="n">FileSystemStorage</span><span class="p">()</span>
        <span class="n">file_suffix</span> <span class="o">=</span> <span class="n">random_string</span><span class="p">(</span><span class="mi">15</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">lenght2</span><span class="p">):</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="s1">&#39;media/&#39;</span><span class="o">+</span><span class="n">user</span><span class="p">,</span> <span class="n">acc_arr2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="n">file_suffix</span><span class="o">+</span><span class="s1">&#39;.gb&#39;</span><span class="p">),</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">gb_file</span><span class="p">:</span>
                <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
                    <span class="s1">&#39;media/&#39;</span><span class="o">+</span><span class="n">user</span><span class="p">,</span> <span class="n">acc_arr2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">+</span><span class="n">file_suffix</span><span class="o">+</span><span class="s1">&#39;.gb&#39;</span><span class="p">)</span>
                <span class="n">gb_file</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">acc_arr</span><span class="p">[</span><span class="n">i</span><span class="p">])</span>
                <span class="n">url</span> <span class="o">=</span> <span class="n">filesy</span><span class="o">.</span><span class="n">url</span><span class="p">(</span><span class="n">gb_file</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
                <span class="n">Url</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">create</span><span class="p">(</span>
                    <span class="n">title</span><span class="o">=</span><span class="n">acc_arr2</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">user</span><span class="o">=</span><span class="n">user_name</span><span class="p">,</span> <span class="n">gb</span><span class="o">=</span><span class="n">path</span><span class="p">)</span>
                <span class="n">urls</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">url</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">urls</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;Not found results.&quot;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">urls</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      <h3><span id="random_string" href="random_string"> Random_string </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">random_string</span><span class="p">(</span><span class="n">string_lenght</span><span class="o">=</span><span class="mi">8</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      <p>Generate random names unique</p>
<p>Keyword Arguments:</p>
<p>string_lenght {int} &ndash; name (default: {8})</p>
<p>Returns:</p>
<p>[str] &ndash; random name</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">letters</span> <span class="o">=</span> <span class="n">string</span><span class="o">.</span><span class="n">ascii_lowercase</span>
    <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">random</span><span class="o">.</span><span class="n">choice</span><span class="p">(</span><span class="n">letters</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">string_lenght</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <h3><span id="search_something_structure" href="search_something_structure"> Search_something_structure </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">search_something_structure</span><span class="p">(</span><span class="n">term_search</span><span class="p">,</span> <span class="n">max_search</span><span class="p">,</span> <span class="n">user</span><span class="p">,</span> <span class="n">database</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <p>Manage the Search Term section of the menu when the user chooses the NCBI Structure database.
With Entrez you search for the term entered in the NCBI.
It shows the links of the proteins in 3D.</p>
<p>Arguments:</p>
<p>term_search {str} &ndash; term entered in the input Term</p>
<p>max_search {int} &ndash; number of downloads</p>
<p>user {str} &ndash; user_id</p>
<p>database {str} &ndash; Structure</p>
<p>Returns:</p>
<pre><code>[] -- links
</code></pre>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="s1">&#39;media/&#39;</span><span class="o">+</span><span class="n">user</span><span class="p">,</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">urls</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="n">Entrez</span><span class="o">.</span><span class="n">email</span> <span class="o">=</span> <span class="s2">&quot;estefani.val34@gmail.com&quot;</span>

    <span class="k">with</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">esearch</span><span class="p">(</span><span class="n">db</span><span class="o">=</span><span class="n">database</span><span class="p">,</span>
                        <span class="n">term</span><span class="o">=</span><span class="n">term_search</span><span class="p">,</span>
                        <span class="n">idtype</span><span class="o">=</span><span class="s2">&quot;acc&quot;</span><span class="p">,</span>
                        <span class="n">retmax</span><span class="o">=</span><span class="n">max_search</span><span class="p">)</span> <span class="k">as</span> <span class="n">response</span><span class="p">:</span>
        <span class="n">res</span> <span class="o">=</span> <span class="n">Entrez</span><span class="o">.</span><span class="n">read</span><span class="p">(</span><span class="n">response</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">res</span><span class="p">[</span><span class="s1">&#39;Count&#39;</span><span class="p">]</span> <span class="o">!=</span> <span class="s1">&#39;0&#39;</span><span class="p">:</span>
        <span class="n">urls</span> <span class="o">=</span> <span class="n">res</span><span class="p">[</span><span class="s2">&quot;IdList&quot;</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">urls</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;Not found results.&quot;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">urls</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
